/*
	File:		Calendar.r

	Contains:	Resources for Calendar

	Change History (most recent first):

	<3>	4/21/95	JS		Updated for Developer Release 2
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E, Soldan, T. elik, J. Alfke, R. Adkins, J. Schalk
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#ifndef __TYPES_R__
#include "Types.r"
#endif

#include "CodeFragmentTypes.r"

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include "StdDefs.h"
#endif

#ifndef _CALENDARDEF_
#include "CalendarDef.h"
#endif

//----------------------------------------------------------------------------------------

#ifdef PowerPC

resource 'cfrg' (0) {
	{	/* array memberArray: 2 elements */
		/* [1] */
		kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ManicMoose::Calendar",
		/* [2] */
		kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"Calendar"
	}
};

#else

resource 'cfrg' (0) {
	{	/* array memberArray: 2 elements */
		/* [1] */
		kMotorola,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ManicMoose::Calendar",
		/* [2] */
		kMotorola,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"Calendar"
	}
};

#endif

//----------------------------------------------------------------------------------------
// nmap resources
//----------------------------------------------------------------------------------------

resource 'nmap' (128) {
	"KindCategories",
	{	/* array KeyList: 1 elements */
		/* [1] */
		"ManicMoose:Kind:Calendar",
		kODIsAnISOStringList {
			{	/* array ValueList: 1 elements */
				/* [1] */
				"ManicMoose:Category:Calendar"
			}
		}
	}
};

resource 'nmap' (129) {
	"EditorKinds",
	{	/* array KeyList: 1 elements */
		/* [1] */
		"ManicMoose::Calendar",
		kODIsAnISOStringList {
			{	/* array ValueList: 1 elements */
				/* [1] */
				"ManicMoose:Kind:Calendar"
			}
		}
	}
};

resource 'nmap' (130) {
	"EditorUserString",
	{	/* array KeyList: 1 elements */
		/* [1] */
		"ManicMoose::Calendar",
		kODIsINTLText {
			0,
			0,
			"Calendar 1.0"
		}
	}
};

resource 'nmap' (131) {
	"KindUserString",
	{	/* array KeyList: 1 elements */
		/* [1] */
		"ManicMoose:Kind:Calendar",
		kODIsINTLText {
			0,
			0,
			"Calendar Kind"
		}
	}
};

resource 'nmap' (132) {
	"CategoryUserString",
	{	/* array KeyList: 1 elements */
		/* [1] */
		"ManicMoose:Category:Calendar",
		kODIsINTLText {
			0,
			0,
			"Calendar Category"
		}
	}
};

resource 'nmap' (133) {
	"KindOldMacOSType",
	{	/* array KeyList: 1 elements */
		/* [1] */
		"ManicMoose:Kind:Calendar",
		kODIsMacOSType {
			kDocumentFileType
		}
	}
};

//----------------------------------------------------------------------------------------
// Bundles
//----------------------------------------------------------------------------------------

resource 'FREF' (128) {
	kDocumentFileType,
	0,
	""
};

resource 'FREF' (130) {
	'shlb',
	0,
	""
};

resource 'FREF' (129) {
	kStationeryFileType,
	1,
	""
};

resource 'FREF' (131) {
	'shlb',
	0,
	""
};

resource 'BNDL' (5000, "Document BNDL") {
	kOpenDocShellSignature,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 128,
			/* [2] */
			1, 129
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 5000,
			/* [2] */
			1, 5001
		}
	}
};

resource 'BNDL' (5001, "Editor BNDL") {
	kViewerFileType,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 130
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 500
		}
	}
};

resource 'BNDL' (5002, "Viewer BNDL") {
	kEditorFileType,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 131
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 501
		}
	}
};

data kOpenDocShellSignature (0, "Owner resource") {
	$"00"
};

data kViewerFileType (0, "Owner resource") {
	$"00"
};

data kEditorFileType (0, "Owner resource") {
	$"00"
};

//----------------------------------------------------------------------------------------
// Resources that are better maintained with ResEdit/Resorcerer
//----------------------------------------------------------------------------------------

Include "Calendar.ResEdit";

//----------------------------------------------------------------------------------------
// AETE for Semantic Interface
//----------------------------------------------------------------------------------------

#include "CalendarAETE.r"