/*
	File:		Calendar.cpp
	Contains:	Implementation of the SOM class Calendar
	Written by:	PartMaker

	Change History (most recent first):

	<3>	4/18/95	JS		Updated to Developer Release 2
						Add ClonePartInfo.
						Inherited for InitPart, InitPartFromStorage.
						Fixed Externalize() inherited call.
						Removed inherited from Release().
						delete to ODDeleteObject().
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, R. Adkins, D. Nelson, J. Schalk
*/

#ifndef _ALTPOINT_
#include <AltPoint.h>
#endif

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#ifndef SOM_ODStorageUnit_xh
#include <StorageU.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef _CPCALENDAR_
#include "CPCalendar.h"
#endif

#define SOM_Module_calendar_Source
#define VARIABLE_MACROS

#ifndef SOM_ManicMoose_Calendar_xih
#include <Calendar.xih>
#endif

#ifndef _ODUTILS_
#include <ODUtils.h>
#endif

//========================================================================================
// ManicMoose_Calendar
//========================================================================================

SOM_Scope void  SOMLINK ManicMoose_CalendarsomInit(ManicMoose_Calendar *somSelf)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart = kODNULL;
    ManicMoose_Calendar_parent_ODPart_somInit(somSelf);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarsomUninit(ManicMoose_Calendar *somSelf)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	if (_fCPPart)
		ODDeleteObject(_fCPPart);
    ManicMoose_Calendar_parent_ODPart_somUninit(somSelf);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarFulfillPromise(ManicMoose_Calendar *somSelf,
		Environment *ev,
		ODStorageUnitView* promiseSUView)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->FulfillPromise(ev,promiseSUView);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDropCompleted(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODPart* destPart,
		ODDropResult dropResult)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DropCompleted(ev,destPart,dropResult);
}

SOM_Scope ODDragResult  SOMLINK ManicMoose_CalendarDragEnter(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->DragEnter(ev,dragInfo,facet,where));
}

SOM_Scope ODDragResult  SOMLINK ManicMoose_CalendarDragWithin(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->DragWithin(ev,dragInfo,facet,where));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDragLeave(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODPoint* where)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DragLeave(ev,facet,where);
}

SOM_Scope ODDropResult  SOMLINK ManicMoose_CalendarDrop(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODDragItemIterator* dropInfo,
		ODFacet* facet,
		ODPoint* where)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->Drop(ev,dropInfo,facet,where));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarContainingPartPropertiesUpdated(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnit* propertyUnit)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->ContainingPartPropertiesUpdated(ev,frame,propertyUnit);
}

SOM_Scope ODStorageUnit*  SOMLINK ManicMoose_CalendarAcquireContainingPartProperties(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return _fCPPart->AcquireContainingPartProperties(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK ManicMoose_CalendarRevealFrame(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* revealShape)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->RevealFrame(ev,embeddedFrame,revealShape));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarEmbeddedFrameSpec(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODObjectSpec* spec)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->EmbeddedFrameSpec(ev,embeddedFrame,spec);
}

SOM_Scope ODEmbeddedFramesIterator*  SOMLINK ManicMoose_CalendarCreateEmbeddedFramesIterator(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->CreateEmbeddedFramesIterator(ev,frame));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDisplayFrameAdded(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
	ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DisplayFrameAdded(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDisplayFrameRemoved(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DisplayFrameRemoved(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDisplayFrameConnected(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DisplayFrameConnected(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDisplayFrameClosed(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DisplayFrameClosed(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarAttachSourceFrame(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODFrame* sourceFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->AttachSourceFrame(ev,frame,sourceFrame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarFrameShapeChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->FrameShapeChanged(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarViewTypeChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->ViewTypeChanged(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarPresentationChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->PresentationChanged(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarSequenceChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->SequenceChanged(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarWritePartInfo(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->WritePartInfo(ev,partInfo,storageUnitView);
}

SOM_Scope ODInfoType  SOMLINK ManicMoose_CalendarReadPartInfo(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnitView* storageUnitView)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->ReadPartInfo(ev,frame,storageUnitView));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarClonePartInfo(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView,
		ODFrame* scopeFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->ClonePartInfo(ev,key,partInfo,storageUnitView,scopeFrame);
}

SOM_Scope ODID  SOMLINK ManicMoose_CalendarOpen(ManicMoose_Calendar *somSelf,
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return (_fCPPart->Open(ev,frame));
}

SOM_Scope ODFrame*  SOMLINK ManicMoose_CalendarRequestEmbeddedFrame(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* containingFrame,
		ODFrame* baseFrame,
		ODShape* frameShape,
		ODPart* embedPart,
		ODTypeToken viewType,
		ODTypeToken presentation,
		ODBoolean isOverlaid)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return _fCPPart->RequestEmbeddedFrame(ev,containingFrame,baseFrame,frameShape,embedPart,viewType,presentation,isOverlaid);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarRemoveEmbeddedFrame(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->RemoveEmbeddedFrame(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK ManicMoose_CalendarRequestFrameShape(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* frameShape)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return _fCPPart->RequestFrameShape(ev,embeddedFrame,frameShape);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarUsedShapeChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->UsedShapeChanged(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK ManicMoose_CalendarAdjustBorderShape(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* embeddedFacet,
		ODShape* shape)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return _fCPPart->AdjustBorderShape(ev,embeddedFacet,shape);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarFacetAdded(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->FacetAdded(ev,facet);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarFacetRemoved(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->FacetRemoved(ev,facet);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarCanvasChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->CanvasChanged(ev,facet);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarGeometryChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODBoolean clipShapeChanged,
		ODBoolean externalTransformChanged)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->GeometryChanged(ev,facet,clipShapeChanged,externalTransformChanged);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDraw(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODShape* invalidShape)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->Draw(ev,facet,invalidShape);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarCanvasUpdated(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODCanvas* canvas)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->CanvasUpdated(ev,canvas);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarHighlightChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->HighlightChanged(ev,facet);
}

SOM_Scope ODULong  SOMLINK ManicMoose_CalendarGetPrintResolution(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return (_fCPPart->GetPrintResolution(ev,frame));
}

SOM_Scope ODLinkSource*  SOMLINK ManicMoose_CalendarCreateLink(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODByteArray* data)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return _fCPPart->CreateLink(ev,data);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarLinkUpdated(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODLink* updatedLink,
		ODUpdateID id)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->LinkUpdated(ev,updatedLink,id);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarRevealLink(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODLinkSource* linkSource)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->RevealLink(ev,linkSource);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarEmbeddedFrameUpdated(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODUpdateID change)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->EmbeddedFrameUpdated(ev,frame,change);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarLinkStatusChanged(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->LinkStatusChanged(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK ManicMoose_CalendarBeginRelinquishFocus(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return (_fCPPart->BeginRelinquishFocus(ev,focus,ownerFrame,proposedFrame));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarCommitRelinquishFocus(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->CommitRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarAbortRelinquishFocus(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->AbortRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarFocusAcquired(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->FocusAcquired(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarFocusLost(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->FocusLost(ev,focus,ownerFrame);
}

SOM_Scope ODBoolean  SOMLINK ManicMoose_CalendarHasExtension(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return (_fCPPart->HasExtension(ev,extensionName));
}

SOM_Scope ODExtension*  SOMLINK ManicMoose_CalendarAcquireExtension(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	return _fCPPart->AcquireExtension(ev,extensionName);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarReleaseExtension(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODExtension* extension)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	_fCPPart->ReleaseExtension(ev,extension);
}

SOM_Scope ODSize  SOMLINK ManicMoose_CalendarPurge(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODSize size)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    if  (_fCPPart)
		return (_fCPPart->Purge(ev,size));
	else
		return (ManicMoose_Calendar_parent_ODPart_Purge(somSelf,ev,size));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarAcquire(ManicMoose_Calendar *somSelf, 
		Environment *ev)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    ManicMoose_Calendar_parent_ODPart_Acquire(somSelf,ev);

	_fCPPart->Acquire(ev);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarRelease(ManicMoose_Calendar *somSelf, 
		Environment *ev)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    ManicMoose_Calendar_parent_ODPart_Release(somSelf,ev);

    if (_fCPPart)
    	_fCPPart->Release(ev);
    	
	if (somSelf->GetRefCount(ev) == 0)
		somSelf->GetStorageUnit(ev)->GetDraft(ev)->ReleasePart(ev, somSelf);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarReleaseAll(ManicMoose_Calendar *somSelf, 
		Environment *ev)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->ReleaseAll(ev);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarExternalize(ManicMoose_Calendar *somSelf, 
		Environment *ev)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	ManicMoose_Calendar_parent_ODPart_Externalize(somSelf,ev);

	_fCPPart->Externalize(ev);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarCloneInto(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODStorageUnit* storageUnit,
		ODFrame* initiatingFrame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	ManicMoose_Calendar_parent_ODPart_CloneInto(somSelf,ev,key,storageUnit,initiatingFrame);

    _fCPPart->CloneInto(ev,key,storageUnit,initiatingFrame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarExternalizeKinds(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODTypeList* kindset)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->ExternalizeKinds(ev,kindset);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarChangeKind(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODType kind)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->ChangeKind(ev,kind);
}

SOM_Scope ODBoolean  SOMLINK ManicMoose_CalendarHandleEvent(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODEventData* event,
		ODFrame* frame,
		ODFacet* facet,
		ODEventInfo* eventInfo)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->HandleEvent(ev,event,frame,facet,eventInfo));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarAdjustMenus(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->AdjustMenus(ev,frame);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarUndoAction(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->UndoAction(ev,actionState);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarRedoAction(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->RedoAction(ev,actionState);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarDisposeActionState(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODDoneState doneState)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->DisposeActionState(ev,actionState,doneState);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarWriteActionState(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODStorageUnitView* storageUnitView)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    _fCPPart->WriteActionState(ev,actionState,storageUnitView);
}

SOM_Scope ODActionData  SOMLINK ManicMoose_CalendarReadActionState(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODStorageUnitView* storageUnitView)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
    return (_fCPPart->ReadActionState(ev,storageUnitView));
}

SOM_Scope void  SOMLINK ManicMoose_CalendarInitPart(ManicMoose_Calendar *somSelf,
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;
	
	ManicMoose_Calendar_parent_ODPart_InitPart(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPCalendar; // $$$$$ Check to see if it is nil
    _fCPPart->InitPart(ev,storageUnit, (ODPart*)partWrapper);
}

SOM_Scope void  SOMLINK ManicMoose_CalendarInitPartFromStorage(ManicMoose_Calendar *somSelf, 
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    ManicMoose_CalendarData *somThis = ManicMoose_CalendarGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;

	ManicMoose_Calendar_parent_ODPart_InitPartFromStorage(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPCalendar; // $$$$$ Check to see if it is nil
	_fCPPart->InitPartFromStorage(ev,storageUnit, (ODPart*)partWrapper);
}

