//----------------------------------------------------------------------------------------
// Extensions protocol
//----------------------------------------------------------------------------------------

#ifndef _CALENDAR_
#include "CPCalendar.h"
#endif
/*
#ifndef SOM_Module_OpenDoc_StandardExtensions_defined
#include <StdExts.xh>
#endif

#ifndef SOM_CalendarSI_xh
#include <CalendarSI.xh>
#endif

#ifndef SOM_ODNameResolver_xh
#include <NamRslvr.xh>
#endif

#ifndef SOM_ODAppleEvent_xh
#include <ODAplEvt.xh>
#endif

#ifndef SOM_ODOSLToken_xh
#include <ODOSLTkn.xh>
#endif

#ifndef _SIHELPER_
#include <SIHelper.h>
#endif

#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif

#ifndef _ODDESUTL_
#include <ODDesUtl.h>
#endif

#ifndef _ODUTILS_
#include <ODUtils.h>
#endif

#ifndef _LIMITS
#include <limits.h>
#endif
*/
void GetDirectParam(ODSession* session, AppleEvent* message,
		AEDesc* evtDp);

void UpdateUserToken(Environment* ev, ODNameResolver* resolver,
						ODOSLToken* odToken, AEDesc* desc);

#define GETBYTESOFHANDLE(h,typ,skipbytes)								\
	*((typ*)((*(h))+(skipbytes)))										\

#define FIRSTBYTESFROMHANDLE(h, typ)									\
		GETBYTESOFHANDLE(h,typ,0)										\



//------------------------------------------------------------------------------

void GetDirectParam(ODSession* session, AppleEvent* message, AEDesc* evtDp)
{
	AEDesc			localDP = NULL_DESCRIPTOR_DEFINITION;
	Environment*	ev = somGetGlobalEnvironment();
	ODNameResolver* resolver = session->GetNameResolver(ev);

	// Get the direct parameter
	THROW_IF_ERROR(AEGetParamDesc(message, keyDirectObject, typeWildCard,
									&localDP));

	// Make an ODDesc from it.
	ODOSLToken* tmpWrapper = new ODOSLToken();
	tmpWrapper->InitODOSLToken(ev);
	THROW_IF_ERROR( AEDescToODDesc(&localDP, tmpWrapper ) );

	// Is it an OD token?
	ODBoolean isToken = resolver->IsODToken(ev, tmpWrapper);
	ODDeleteObject( tmpWrapper );

	if ( isToken )
		*evtDp = localDP;
	else
	{
		AEDisposeDesc(&localDP);
		THROW( errAEEventNotHandled );
	}
}

//------------------------------------------------------------------------------

void UpdateUserToken(Environment* ev, ODNameResolver* resolver,
						ODOSLToken* odToken, AEDesc* desc)
{
	ODDesc*	userODToken = resolver->GetUserToken(ev, odToken);
	THROW_IF_ERROR(AEDescToODDesc(desc, userODToken));
	THROW_IF_ERROR(AEDisposeDesc(desc));
}
