//----------------------------------------------------------------------------------------
// Part Activation protocol
//----------------------------------------------------------------------------------------

#ifndef _CALENDAR_
#include "CPCalendar.h"
#endif

//----------------------------------------------------------------------------------------

ODBoolean CPCalendar::BeginRelinquishFocus(Environment* ev, ODTypeToken focus,
											  ODFrame* ownerFrame,
											  ODFrame* proposedFrame)
{
	// CodeWarrior: Cmd-Click or Search:Find Definition  Explain_BeginRelinquishFocus
	EnteringMethod("\pCPCalendar::BeginRelinquishFocus");
	ODUnused(ownerFrame);
	ODPart* part = proposedFrame->AcquirePart(ev);
	ODBoolean retval = kODTrue;
	if ((focus == fModalFocus) && (part != fSelf)) {
		retval = kODFalse;
			// What IS ModalFocus, anyway?  The whole purpose of this
			// ModalFocus thing is to restrict frame changes.  This is
			// the part's chance to do this.  But how much to restrict
			//
			// This is an interesting case.  ModalFocus is kind of a weird
			// concept in OpenDoc, as it goes against the principal of
			// being able to click anywhere at any time.  This implementation
			// keeps the focus on the part.  Note that the implementation
			// of ModalFocus might be more restrictive than this.  You may
			// wish to restrict it to a single frame, instead of allowing
			// the focus to move from frame to frame within a single part.
			// If you wish to restrict it to a single frame, then the if
			// should only check if it is a modal focus.
	}
	else {
		// retval = kODTrue; // by default
			// This is the super-script way of handling ModalFocus.  You
			// can NOT switch off the frame to another, no matter what.
	}
	part->Release(ev);
	return retval;
}

//----------------------------------------------------------------------------------------

void CPCalendar::CommitRelinquishFocus(Environment* ev,
										ODTypeToken focus, ODFrame* ownerFrame,
										ODFrame* proposedFrame)
{
	// CodeWarrior: Cmd-Click or Search:Find Definition  Explain_CommitRelinquishFocus
	EnteringMethod("\pCPCalendar::CommitRelinquishFocus");
	ODUnused(proposedFrame);

	this->FocusLost(ev, focus, ownerFrame);
}

//----------------------------------------------------------------------------------------

void CPCalendar::AbortRelinquishFocus(Environment* ev,
									   ODTypeToken focus, ODFrame* ownerFrame,
									   ODFrame* proposedFrame)
{
	// CodeWarrior: Cmd-Click or Search:Find Definition  Explain_AbortRelinquishFocus
	EnteringMethod("\pCPCalendar::AbortRelinquishFocus");
	ODUnused(focus);
	ODUnused(ownerFrame);
	ODUnused(proposedFrame);
}

//----------------------------------------------------------------------------------------

void CPCalendar::FocusAcquired(Environment* ev, ODTypeToken focus, ODFrame* ownerFrame)
{
	// CodeWarrior: Cmd-Click or Search:Find Definition  Explain_FocusAcquired
	EnteringMethod("\pCPCalendar::FocusAcquired");
	if (focus == fMenuFocus)
	{
		if (ownerFrame && fMenuBar)
		{
			fMenuBar->Display(ev);
		}
	}
}

//----------------------------------------------------------------------------------------

void CPCalendar::FocusLost(Environment* ev, ODTypeToken focus, ODFrame* ownerFrame)
{
	// CodeWarrior: Cmd-Click or Search:Find Definition  Explain_FocusLost
	EnteringMethod("\pCPCalendar::FocusLost");
	ODUnused(ownerFrame);

	if (focus == fMenuFocus)
	{
	}
}

