#
#	File:		Calendar.make
#
#	Contains:	Makefile for OpenDoc Calendar
##
#	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.
#

#---------------------------------------------------------------------------	
# PROJECT VARIABLES
#---------------------------------------------------------------------------	

TargetName = Calendar
TargetNameILink = {TargetName} (68k)
TargetNamePPCLink = {TargetName} (PPC)
TargetNameFat = {TargetName} (fat)

TargetCreatorType = PMVW

AdditionalIncludes = -i "{somSourceDir}" -i "{SourceDir}"

#---------------------------------------------------------------------------	
# DIRECTORY DEPENDENCIES
#---------------------------------------------------------------------------	

"{TargetDir}"   "{SourceDir}"
"{ObjectsDir}"  "{SourceDir}"
"{ObjectsDir}"  "{somSourceDir}"
"{ObjectsDir}"  "{ODUtilsImplDir}"

#---------------------------------------------------------------------------	
# ROOT TARGET
#---------------------------------------------------------------------------	

BUILDPPCLINK  
	"{CppPrecompiledHeaders}"			
	"{TargetDir}{TargetNamePPCLink}"	
	"{somSourceDir}Calendar.exp"

BUILDREZ  
	"{ObjectsDir}Calendar.PPC.rsrc"	
	"{ObjectsDir}Calendar.68k.rsrc"

BUILDILINK  
	"{CppPrecompiledHeaders}"			
	"{TargetDir}{TargetNameILink}"		
	"{somSourceDir}Calendar.exp"

BUILDIDL  
	"{somSourceDir}Calendar.xih"	
	"{somSourceDir}Calendar.xh"	
	"{somSourceDir}Calendar.cpp"	
	"{somSourceDir}Calendar.exp"

BUILDFATLIB  
	"{TargetDir}{TargetNameFat}"		
	"{TargetDir}{TargetNamePPCLink}"	
	"{TargetDir}{TargetNameILink}"
	

#---------------------------------------------------------------------------	
# FILE LIST VARIABLES
#---------------------------------------------------------------------------	

CalendarOBJECTS = 
	"{ObjectsDir}CPCalendar.cpp.o"			
	"{ObjectsDir}CPCalendar.Bind.cpp.o"	
	"{ObjectsDir}CPCalendar.DD.cpp.o"		
	"{ObjectsDir}CPCalendar.Embed.cpp.o"	
	"{ObjectsDir}CPCalendar.Event.cpp.o"	
	"{ObjectsDir}CPCalendar.Ext.cpp.o"		
	"{ObjectsDir}CPCalendar.Focus.cpp.o"	
	"{ObjectsDir}CPCalendar.Frame.cpp.o"	
	"{ObjectsDir}CPCalendar.Image.cpp.o"	
	"{ObjectsDir}CPCalendar.InEx.cpp.o"	
	"{ObjectsDir}CPCalendar.Link.cpp.o"	
	"{ObjectsDir}CPCalendar.Undo.cpp.o"	
	"{ObjectsDir}FrameList.cpp.o"			
	"{ObjectsDir}PartUtils.cpp.o"			

somCalendarOBJECTS = 
	"{ObjectsDir}Calendar.cpp.o"			
	"{ObjectsDir}CalendarSI.cpp.o"			
	"{ObjectsDir}CalendarInit.cpp.o"		

OpenDocUtilityOBJECTS = 
	"{ObjectsDir}AltPoint.cpp.o" 			
	"{ObjectsDir}AltPoly.cpp.o" 			
	"{ObjectsDir}Except.cpp.o" 				
	"{ObjectsDir}FocusLib.cpp.o" 			
	"{ObjectsDir}IText.cpp.o" 				
	"{ObjectsDir}FlipEnd.cpp.o" 			
	"{ObjectsDir}ISOStr.cpp.o" 				
	"{ObjectsDir}LinkList.cpp.o" 			
	"{ObjectsDir}ODDebug.cpp.o" 			
	"{ObjectsDir}ODMemory.cpp.o"			
	"{ObjectsDir}ODUtils.cpp.o"				
	"{ObjectsDir}PasclStr.cpp.o"			
	"{ObjectsDir}POUtils.cpp.o"				
	"{ObjectsDir}StorUtil.cpp.o"			
	"{ObjectsDir}StdTypIO.cpp.o"			
	"{ObjectsDir}UseRsrcM.cpp.o" 			
	"{ObjectsDir}WinUtils.cpp.o" 			
			
# List of Utilities unused. Add as required

UtilitiesOBJECTS = 
	"{ObjectsDir}BArray.cpp.o" 				
	"{ObjectsDir}DictList.cpp.o" 			
	"{ObjectsDir}DlogUtil.cpp.o" 			
	"{ObjectsDir}EditrSet.cpp.o" 			
	"{ObjectsDir}HshTbl.c.o" 				
	"{ObjectsDir}LineOps.cpp.o" 			
	"{ObjectsDir}List.cpp.o" 				
	"{ObjectsDir}Node.cpp.o" 				
	"{ObjectsDir}ODMathM.a.o" 				
	"{ObjectsDir}ODMathM.cpp.o" 			
	"{ObjectsDir}OpenHash.cpp.o" 			
	"{ObjectsDir}OrdColl.cpp.o" 			
	"{ObjectsDir}PlfmFile.cpp.o" 			
	"{ObjectsDir}PriortyQ.cpp.o" 			
	"{ObjectsDir}RegisterFileLibs.c.o" 		
	"{ObjectsDir}SIHelper.cpp.o" 			
	"{ObjectsDir}SIHshTbl.cpp.o" 			
	"{ObjectsDir}StdIFmIO.cpp.o" 			
	"{ObjectsDir}StrHshTb.cpp.o" 			
	"{ObjectsDir}TransUtl.cpp.o" 			
	
#---------------------------------------------------------------------------	
# DEPENDENCIES
#---------------------------------------------------------------------------	

# --- IDL ---

"{somSourceDir}"Calendar.cpp 	
	"{somSourceDir}"Calendar.idl	
	"{ODIDLIntfDir}"Part.idl
	
"{somSourceDir}"Calendar.xih 	
	"{somSourceDir}"Calendar.xh	
	"{somSourceDir}"Calendar.idl	
	"{ODIDLIntfDir}"Part.idl
	
"{somSourceDir}"Calendar.xh 		
	"{somSourceDir}"Calendar.idl	
	"{ODIDLIntfDir}"Part.idl

# --- SOURCE ---

"{ObjectsDir}"CalendarInit.cpp.o  	
	"{LocalIDLDir}"CalendarInit.cpp	
	"{LocalIDLDir}"Calendar.xh

"{ObjectsDir}"CPCalendar.cpp.o  		
	"{ProjectDir}"CPCalendar.cpp		
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h
	
"{ObjectsDir}"CPCalendar.Bind.cpp.o  	
	"{SourceDir}"CPCalendar.Bind.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.DD.cpp.o  	
	"{SourceDir}"CPCalendar.DD.cpp		
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Embed.cpp.o  
	"{SourceDir}"CPCalendar.Embed.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Event.cpp.o  
	"{SourceDir}"CPCalendar.Event.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Ext.cpp.o  	
	"{SourceDir}"CPCalendar.Ext.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Focus.cpp.o  
	"{SourceDir}"CPCalendar.Focus.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Frame.cpp.o  
	"{SourceDir}"CPCalendar.Frame.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Image.cpp.o  
	"{SourceDir}"CPCalendar.Image.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.InEx.cpp.o  	
	"{SourceDir}"CPCalendar.InEx.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Link.cpp.o  	
	"{SourceDir}"CPCalendar.Link.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

"{ObjectsDir}"CPCalendar.Undo.cpp.o  	
	"{SourceDir}"CPCalendar.Undo.cpp	
	"{HeaderDir}"CPCalendar.h			
	"{HeaderDir}"CalendarDef.h

# --- SOM OBJECTS ---

"{ObjectsDir}Calendar.cpp.o"								
	"{somSourceDir}Calendar.cpp"							
	"{somSourceDir}Calendar.xih"

"{ObjectsDir}CalendarInit.cpp.o"							
	"{somSourceDir}CalendarInit.cpp"						
	"{somSourceDir}Calendar.xh"

# --- OPENDOC UTILITIES ---

"{ObjectsDir}AltPoint.cpp.o"									
	"{ODUtilsIntfDir}AltPoint.h" 								
	"{ODUtilsImplDir}AltPoint.cpp"

"{ObjectsDir}AltPoly.cpp.o"										
	"{ODUtilsIntfDir}AltPoly.h" 								
	"{ODUtilsImplDir}AltPoly.cpp"

"{ObjectsDir}Except.cpp.o"										
	"{ODUtilsIntfDir}Except.h" 									
	"{ODUtilsImplDir}Except.cpp"

"{ObjectsDir}FocusLib.cpp.o"									
	"{ODUtilsIntfDir}FocusLib.h" 								
	"{ODUtilsImplDir}FocusLib.cpp"

"{ObjectsDir}IText.cpp.o"										
	"{ODUtilsIntfDir}IText.h" 									
	"{ODUtilsImplDir}IText.cpp"

"{ObjectsDir}FlipEnd.cpp.o"										
	"{ODUtilsIntfDir}FlipEnd.h" 								
	"{ODUtilsImplDir}FlipEnd.cpp"

"{ObjectsDir}ISOStr.cpp.o"										
	"{ODUtilsIntfDir}ISOStr.h" 									
	"{ODUtilsImplDir}ISOStr.cpp"

"{ObjectsDir}LinkList.cpp.o"									
	"{ODUtilsIntfDir}LinkList.h" 								
	"{ODUtilsImplDir}LinkList.cpp"

"{ObjectsDir}ODDebug.cpp.o"										
	"{ODUtilsIntfDir}ODDebug.h" 								
	"{ODUtilsImplDir}ODDebug.cpp"

"{ObjectsDir}ODMemory.cpp.o"									
	"{ODUtilsIntfDir}ODMemory.h" 								
	"{ODUtilsImplDir}ODMemory.cpp"

"{ObjectsDir}ODUtils.cpp.o"										
	"{ODUtilsIntfDir}ODUtils.h" 								
	"{ODUtilsImplDir}ODUtils.cpp"

"{ObjectsDir}PasclStr.cpp.o"									
	"{ODUtilsIntfDir}PasclStr.h" 								
	"{ODUtilsImplDir}PasclStr.cpp"

"{ObjectsDir}POUtils.cpp.o"										
	"{ODUtilsIntfDir}POUtils.h" 								
	"{ODUtilsImplDir}POUtils.cpp"

"{ObjectsDir}StorUtil.cpp.o"									
	"{ODUtilsIntfDir}StorUtil.h" 								
	"{ODUtilsImplDir}StorUtil.cpp"

"{ObjectsDir}StdTypIO.cpp.o"									
	"{ODUtilsIntfDir}StdTypIO.h" 								
	"{ODUtilsImplDir}StdTypIO.cpp"

"{ObjectsDir}UseRsrcM.cpp.o"									
	"{ODUtilsIntfDir}UseRsrcM.h" 								
	"{ODUtilsImplDir}UseRsrcM.cpp"

"{ObjectsDir}WinUtils.cpp.o"									
	"{ODUtilsIntfDir}WinUtils.h" 								
	"{ODUtilsImplDir}WinUtils.cpp"


#---------------------------------------------------------------------------	
# BUILD LIBRARIES
#---------------------------------------------------------------------------	

# --- 68k Link ---

"{TargetDir}{TargetNameILink}"  	 {CalendarOBJECTS}			
									 {somCalendarOBJECTS}			
									 {OpenDocUtilityOBJECTS}		
									 "{somSourceDir}Calendar.exp"
	Echo Linking: {TargetNameILink}
	ILink	
		-export `ConvertExportList "{somSourceDir}Calendar.exp"` 
		{ILinkOptions}										
		{ILinkShLibOptions}									
		-init CalendarCFMInit								
		-m CalendarSOMInit								
		{ShLibPreLibraries}									
		{CalendarOBJECTS}									
		{somCalendarOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{ShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNameILink}".seg
	If !{Status}
		Echo Building: {TargetNameILink}.SYM
		ILinkToSym "{ObjectsDir}{TargetNameILink}".seg.NJ 
			-o "{TargetDir}{TargetNameILink}".SYM -sym 3.2
		Echo Building: {TargetNameILink}'s code/data fragment
		MakeFlat "{ObjectsDir}{TargetNameILink}".seg -o "{TargetDir}{TargetNameILink}"
		Echo Copying: {TargetNameILink}'s resources
		Echo "include "{ObjectsDir}Calendar.68k.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End

# --- PowerPC Link ---

"{TargetDir}{TargetNamePPCLink}" 		{CalendarOBJECTS}			
										{somCalendarOBJECTS}		
										{OpenDocUtilityOBJECTS}		
										"{somSourceDir}Calendar.exp"
	Echo Linking: {TargetNamePPCLink}
	PPCLink	
		-export `ConvertExportList "{somSourceDir}Calendar.exp"` 
		{PPCLinkOptions}									
		{PPCLinkShLibOptions}								
		-main CalendarSOMInit								
		-init CalendarCFMInit								
		{PPCShLibPreLibraries}								
		{CalendarOBJECTS}									
		{somCalendarOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{PPCShLibPostLibraries}								
		{XCOFFRenameOptions}								
		-o "{ObjectsDir}{TargetNamePPCLink}"
	If !{Status}
		Move "{ObjectsDir}{TargetNamePPCLink}" "{TargetDir}"
		Echo Building: {TargetNamePPCLink}.xSYM
		MakeSym "{ObjectsDir}{TargetNamePPCLink}".xcoff				
				{AdditionalIncludes} -i "{ODUtilsImplDir}"			
				-sym on,3.2 -o "{TargetDir}{TargetNamePPCLink}".xSYM
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include "{ObjectsDir}Calendar.PPC.rsrc";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End


#---------------------------------------------------------------------------	
# REZ STEPS
#---------------------------------------------------------------------------	

"{ObjectsDir}"Calendar.PPC.rsrc 	"{SourceDir}"Calendar.r 
									"{SourceDir}CalendarDef.h" 
									"{SourceDir}CalendarOtherResources.rsrc"
	Echo Rezzing: Calendar.r (for PPC)
	Rez {RezOptions} {ODRezIntf} "{SourceDir}"Calendar.r 
		 -a -o "{ObjectsDir}PPC:"Calendar.PPC.rsrc
	Echo Copying: {TargetNamePPCLink}'s resources
	Echo "include "{ObjectsDir}PPC:Calendar.PPC.rsrc";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
	Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
	

"{ObjectsDir}"Calendar.68k.rsrc 	"{SourceDir}"Calendar.r 
									"{SourceDir}CalendarDef.h" 
									"{SourceDir}CalendarOtherResources.rsrc"
	Echo Rezzing: Calendar.r (for 68k)
	Rez -d _68KBUILD_ {RezOptions} {ODRezIntf} "{SourceDir}"Calendar.r 
		 -a -o "{ObjectsDir}68k:"Calendar.68k.rsrc
	Echo Copying: {TargetNameILink}'s resources
	Echo "include "{ObjectsDir}68k:Calendar.68k.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
	Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"


#---------------------------------------------------------------------------	
# MAKE FAT LIBRARY
#---------------------------------------------------------------------------	

"{TargetDir}{TargetNameFat}" 	"{TargetDir}{TargetNamePPCLink}" 
								"{TargetDir}{TargetNameILink}"
	"{MakeFat}" "{TargetDir}{TargetNameILink}" "{TargetDir}{TargetNamePPCLink}" 
			-o "{TargetDir}{TargetNameFat}"